diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index 887ae1c37..88b496b5d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -3,6 +3,7 @@ package net.minecraft.core.world.generate.chunk.perlin.nether;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
@@ -64,8 +65,8 @@ public class SurfaceGeneratorNether
                     int block = result.getBlock(x, y, z);
 
                     if ((biome != lastBiome || topBlock == -1 || fillerBlock == -1) && block == 0) {
-                        topBlock = biome.topBlock;
-                        fillerBlock = biome.fillerBlock;
+                        topBlock = (short) biome.getSurfaceProperties().getTopBlock().id();
+                        fillerBlock = (short) biome.getSurfaceProperties().getFillerBlock().id();
                     }
                     lastBiome = biome;
 
@@ -87,12 +88,12 @@ public class SurfaceGeneratorNether
                             topBlock = 0;
                             fillerBlock = (short) Blocks.NETHERRACK.id();
                         } else {
-                            boolean biomeGeneratesSulfur = biome == Biomes.NETHER_SULFUR_POOLS;
+                            boolean biomeGeneratesSulfur = biome.hasTag(BiomeTags.HAS_SULFUR_POOLS);
 
                             if (y >= minY + oceanY - 4 && y <= minY + oceanY + 1) {
                                 // Generate coastlines
-                                topBlock = biome.topBlock;
-                                fillerBlock = biome.fillerBlock;
+                                topBlock = (short) biome.getSurfaceProperties().getTopBlock().id();
+                                fillerBlock = (short) biome.getSurfaceProperties().getFillerBlock().id();
                                 if (generateGravelBeach) {
                                     topBlock = (short) Blocks.GRAVEL.id();
                                     fillerBlock = (short) Blocks.GRAVEL.id();
@@ -133,7 +134,7 @@ public class SurfaceGeneratorNether
 
                     if(currentLayerDepth == 0)
                     {
-                        if(biome == Biomes.NETHER_SULFUR_POOLS && fillerBlock == Blocks.BRIMSAND.id()) {
+                        if(biome.hasTag(BiomeTags.HAS_SULFUR_POOLS) && fillerBlock == Blocks.BRIMSAND.id()) {
                             currentLayerDepth = rand.nextInt(4) + 2;
                             fillerBlock = (short)Blocks.BRIMSAND.id();
                         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
index 28ffa3202..8fa73ae04 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/TerrainGeneratorNether.java
@@ -5,6 +5,7 @@ import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkSection;
@@ -42,7 +43,7 @@ public class TerrainGeneratorNether
         this.fluidLookup.put(Biomes.NETHER_CRAG, Blocks.FLUID_LAVA_STILL.id());
         this.fluidLookup.put(Biomes.NETHER_SHELF, Blocks.COBBLE_NETHERRACK.id());
         this.fluidLookup.put(Biomes.NETHER_CRYSTAL_FOREST, Blocks.FLUID_WATER_STILL.id());
-        this.fluidLookup.put(Biomes.NETHER_CRYSTAL_FIELD, Blocks.FLUID_WATER_STILL.id());
+        this.fluidLookup.put(Biomes.NETHER_CRYSTAL_PLAINS, Blocks.FLUID_WATER_STILL.id());
         this.fluidLookup.put(Biomes.NETHER_OLD_WORLD, Blocks.FLUID_WATER_STILL.id());
 
         this.minY = world.getWorldType().getMinY(world);
@@ -72,7 +73,7 @@ public class TerrainGeneratorNether
         } else if (y <= quarterHeight + this.rand.nextInt(5)) {
             return Blocks.BEDROCK.id();
         } else if (density > 0.0) {
-            if (this.lastBiome == Biomes.NETHER_CRYSTAL_FOREST || this.lastBiome == Biomes.NETHER_CRYSTAL_FIELD) {
+            if (this.lastBiome != null && this.lastBiome.hasTag(BiomeTags.HAS_CRYSTAL_VEINS)) {
                 int sizeY = Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
                 // YZX ordering
                 final double d = ((this.cache[(x * Chunk.CHUNK_SIZE_Z * sizeY) + (z * sizeY) + y]));
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
index 5029744b0..d7c7a0ae3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/ChunkDecoratorOverworld.java
@@ -12,15 +12,16 @@ import net.minecraft.core.block.BlockLogicSand;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.noise.FractalNoise2D;
 import net.minecraft.core.world.noise.ImprovedPerlinNoise;
-import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.overworld.BiomeOutback;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.feature.*;
+import net.minecraft.core.world.type.tag.WorldTypeTags;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -66,7 +67,7 @@ public class ChunkDecoratorOverworld
         Random swampRand = new Random((long) chunkX * l1 + (long) chunkZ * l2 ^ this.world.getRandomSeed());
 
         // Water pass for swamps
-        if (biome == Biomes.OVERWORLD_SWAMPLAND) {
+        if (biome.hasTag(BiomeTags.HAS_SURFACE_WATER)) {
             for (int dx = 0; dx < 16; dx++) {
                 for (int dz = 0; dz < 16; dz++) {
                     int topBlock = this.world.getHeightValue(x + dx, z + dz);
@@ -102,7 +103,7 @@ public class ChunkDecoratorOverworld
             lakeChance = 0;
         if (lakeChance != 0 && rand.nextInt(lakeChance) == 0) {
             int fluid = Blocks.FLUID_WATER_STILL.id();
-            if (biome.hasSurfaceIce()) {
+            if (biome.hasTag(BiomeTags.HAS_SURFACE_ICE)) {
                 fluid = Blocks.ICE.id();
             }
             int i1 = x + rand.nextInt(16) + 8;
@@ -301,7 +302,7 @@ public class ChunkDecoratorOverworld
             for (int i11 = 0; i11 < treeDensity; i11++) {
                 int l13 = x + rand.nextInt(16) + 8;
                 int j14 = z + rand.nextInt(16) + 8;
-                WorldFeature feature = biome.getRandomWorldGenForTrees(rand);
+                WorldFeature feature = biome.getTreeFeature(rand);
                 feature.init(1.0D, 1.0D, 1.0D);
                 feature.place(this.world, rand, l13, this.world.getHeightValue(l13, j14), j14);
             }
@@ -604,12 +605,16 @@ public class ChunkDecoratorOverworld
                 int dy = this.world.getHeightValue(dx, dz);
                 Biome localBiome = this.world.getBlockBiome(dx, dy, dz);
 
-                if ((localBiome.hasSurfaceSnow() || this.world.getWorldType() == WorldTypes.OVERWORLD_WINTER) && dy > 0 && dy < this.world.getHeightBlocks()) {
+                if ((localBiome.hasTag(BiomeTags.HAS_SURFACE_SNOW) || this.world.getWorldType().hasTag(WorldTypeTags.ENDLESS_SNOW)) &&
+                    dy > 0 && dy < this.world.getHeightBlocks())
+                {
                     if (this.world.isAirBlock(dx, dy, dz) && this.world.getBlockMaterial(dx, dy - 1, dz).blocksMotion()) {
                         this.world.setBlockWithNotify(dx, dy, dz, Blocks.LAYER_SNOW.id());
                     }
                 }
-                if ((localBiome.hasSurfaceIce() || this.world.getWorldType() == WorldTypes.OVERWORLD_WINTER) && (this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_STILL.id() || this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_FLOWING.id())) {
+                if ((localBiome.hasTag(BiomeTags.HAS_SURFACE_ICE) || this.world.getWorldType().hasTag(WorldTypeTags.ENDLESS_SNOW)) &&
+                    (this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_STILL.id() || this.world.getBlockId(dx, oceanY - 1, dz) == Blocks.FLUID_WATER_FLOWING.id())
+                ) {
                     this.world.setBlockWithNotify(dx, oceanY - 1, dz, Blocks.ICE.id());
                 }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
index 07ecdc60e..6b6f8429b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
@@ -5,6 +5,7 @@ import java.util.Random;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkGeneratorResult;
@@ -118,8 +119,8 @@ public class SurfaceGeneratorOverworld
 
                     if ((biome != lastBiome || topBlock == -1 || fillerBlock == -1) && block == 0)
                     {
-                        topBlock = biome.topBlock;
-                        fillerBlock = biome.fillerBlock;
+                        topBlock = (short) biome.getSurfaceProperties().getTopBlock().id();
+                        fillerBlock = (short) biome.getSurfaceProperties().getFillerBlock().id();
                     }
                     lastBiome = biome;
 
@@ -147,17 +148,13 @@ public class SurfaceGeneratorOverworld
                         }
                         else {
                             //todo: biome tags
-                            boolean biomeGeneratesMud = biome ==
-                                    Biomes.OVERWORLD_CAATINGA_PLAINS ||
-                                    biome == Biomes.OVERWORLD_CAATINGA ||
-                                    biome == Biomes.OVERWORLD_SWAMPLAND ||
-                                    biome == Biomes.OVERWORLD_SWAMPLAND_MUDDY;
+                            boolean biomeGeneratesMud = biome.hasTag(BiomeTags.HAS_SURFACE_MUD);
 
                             if(y >= minY + oceanY - 4 && y <= minY + oceanY + 1)
                             {
                                 // generate coastlines
-                                topBlock = biome.topBlock;
-                                fillerBlock = biome.fillerBlock;
+                                topBlock = (short) biome.getSurfaceProperties().getTopBlock().id();
+                                fillerBlock = (short) biome.getSurfaceProperties().getFillerBlock().id();
                                 if(biomeGeneratesMud)
                                 {
                                     topBlock = (short) Blocks.MUD.id();
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
index 6c92100ee..8838e954b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
@@ -2,6 +2,7 @@ package net.minecraft.core.world.generate.chunk.perlin.overworld;
 
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
index 9878ff5b1..3b09b9038 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/b173/ChunkDecoratorOverworldB173.java
@@ -4,6 +4,7 @@ import net.minecraft.core.block.BlockLogicSand;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
+import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
@@ -168,9 +169,9 @@ public class ChunkDecoratorOverworldB173
         for (int i = 0; i < numTrees; i++) {
             final int fx = wx + rand.nextInt(16) + 8;
             final int fz = wz + rand.nextInt(16) + 8;
-            final @NotNull WorldFeature feature = biome.getRandomWorldGenForTrees(rand);
+            final @NotNull WorldFeature feature = biome.getTreeFeature(rand);
             feature.init(1.0, 1.0, 1.0);
-            biome.getRandomWorldGenForTrees(rand).place(this.world, rand, fx, this.world.getHeightValue(fx, fz), fz);
+            biome.getTreeFeature(rand).place(this.world, rand, fx, this.world.getHeightValue(fx, fz), fz);
         }
 
         int numYellowFlowers = 0;
@@ -302,12 +303,12 @@ public class ChunkDecoratorOverworldB173
                 int yy = this.world.getHeightValue(xx, zz);
                 final Biome localBiome = this.world.getBlockBiome(xx, yy, zz);
 
-                if (localBiome.hasSurfaceSnow() && yy > 0 && yy < this.world.getHeightBlocks()) {
+                if (localBiome.hasTag(BiomeTags.HAS_SURFACE_SNOW) && yy > 0 && yy < this.world.getHeightBlocks()) {
                     if (this.world.isAirBlock(xx, yy, zz) && this.world.getBlockMaterial(xx, yy - 1, zz).blocksMotion()) {
                         this.world.setBlockWithNotify(xx, yy, zz, Blocks.LAYER_SNOW.id());
                     }
                 }
-                if (localBiome.hasSurfaceIce() && (this.world.getBlockId(xx, oceanY - 1, zz) == Blocks.FLUID_WATER_STILL.id() || this.world.getBlockId(xx, oceanY - 1, zz) == Blocks.FLUID_WATER_FLOWING.id())) {
+                if (localBiome.hasTag(BiomeTags.HAS_SURFACE_ICE) && (this.world.getBlockId(xx, oceanY - 1, zz) == Blocks.FLUID_WATER_STILL.id() || this.world.getBlockId(xx, oceanY - 1, zz) == Blocks.FLUID_WATER_FLOWING.id())) {
                     this.world.setBlockWithNotify(xx, oceanY - 1, zz, Blocks.ICE.id());
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
index af0ab3fdf..e9d4aa976 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/WorldType.java
@@ -2,6 +2,8 @@ package net.minecraft.core.world.type;
 
 import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.data.tag.ITaggable;
+import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
@@ -20,9 +22,14 @@ import net.minecraft.core.world.wind.WindProviderGeneric;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
 import java.util.Random;
 
-public abstract class WorldType {
+public abstract class WorldType
+    implements ITaggable<WorldType>
+{
     private final String languageKey;
     private final Weather defaultWeather;
     private final WindProvider windProvider;
@@ -38,7 +45,6 @@ public abstract class WorldType {
     private final int fillerBlockId;
     private final int dayNightCycleTicks;
     private final boolean mayRespawn;
-    private final boolean isRetro;
 
     public WorldType(Properties properties) {
         this.languageKey = properties.languageKey;
@@ -64,7 +70,10 @@ public abstract class WorldType {
         this.fillerBlockId = properties.fillerBlock == null ? 0 : properties.fillerBlock.id();
         this.dayNightCycleTicks = properties.dayNightCycleTicks;
         this.mayRespawn = properties.mayRespawn;
-        this.isRetro = properties.isRetro;
+
+        for (final @NotNull Tag<WorldType> tag : properties.tags) {
+            tag.tag(this);
+        }
     }
 
     public String getLanguageKey() {
@@ -127,10 +136,6 @@ public abstract class WorldType {
         return mayRespawn;
     }
 
-    public boolean isRetro() {
-        return isRetro;
-    }
-
     public void onWorldCreation(World world) { }
 
     public final int getYRange(final @NotNull World world) {
@@ -286,6 +291,15 @@ public abstract class WorldType {
 
     public abstract int getSkyDarken(World world, long tick, float partialTick);
 
+    public boolean hasTag(final @NotNull Tag<WorldType> tag) {
+        return tag.appliesTo(this);
+    }
+
+    @Override
+    public boolean isIn(Tag<WorldType> tag) {
+        return tag.appliesTo(this);
+    }
+
     public static class Properties {
         private final String languageKey;
         private Weather defaultWeather = null;
@@ -302,7 +316,7 @@ public abstract class WorldType {
         private @Nullable Block<?> fillerBlock = null;
         private int dayNightCycleTicks = Global.DAY_LENGTH_TICKS;
         private boolean mayRespawn = false;
-        private boolean isRetro = false;
+        private final @NotNull List<Tag<WorldType>> tags = new ArrayList<>();
 
         private Properties(String languageKey) {
             this.languageKey = languageKey;
@@ -393,8 +407,9 @@ public abstract class WorldType {
             return this;
         }
 
-        public @NotNull Properties setRetro() {
-            this.isRetro = true;
+        @SafeVarargs
+        public final @NotNull Properties withTags(final @NotNull Tag<WorldType>... tags) {
+            this.tags.addAll(Arrays.asList(tags));
             return this;
         }
     }
